.docker_login: &docker-login
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}

.docker_build_dind: &docker-build-dind
    - docker build -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} .

.docker_push: &docker-push
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
    - if [[ ${CI_COMMIT_REF_SLUG} == "main" ]]; then
          docker tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} ${CI_REGISTRY_IMAGE}:latest; fi
    - if [[ ${CI_COMMIT_REF_SLUG} == "main" ]]; then
          docker push ${CI_REGISTRY_IMAGE}:latest; fi

.docker_build:
  stage: build
  image: docker:stable
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""
  services:
    - name: docker:dind


  script:
    - *docker-login
    - *docker-build-dind
    - *docker-push
  tags:
    - docker